setInfos(6, "The White Queen", "Play strip blackjack with a professional with optional estim", "Doti, Liz", "v1.1", 0x08A608, "en", ["femaledom", "maledom", "formale", "forfemale", "game", "estim"]);

// The white Queen, written by Doti
// v1.1 - Liz
// - Additions to allow e-stim, inspired by ptdw
// - Strip if lost
// Todo
// - Improve stripping code?
// - Shock more if double + selected non audio estim
			
def imPrefix = "whitequeen/f"
if(loadBoolean("intro.likemale") && (getRandom(3)==0 || !loadBoolean("intro.likefemale")))
	imPrefix = "whitequeen/m"
setImage(imPrefix+"1.jpg")
show("Hello, "+loadString("intro.name")+", you're having a good party ?\n"+
		"Your \"friends\" gave me four \$50 bills to play with you, but it seems "+
		"they didn't want it too be too easy.\n\nI think we should both start with "+
		"4 items of clothing and see what happens ;-).")
showButton("Oh yeah ?")

setImage(imPrefix+"2.jpg")
if(!getBoolean("Yes, so I'll be the dealer for those \$50 bills, you know, in a "+
		"game of blackjack. Clothes for the first victories, double "+
		"this bet - \$400 - and you have me.\n\nYou know how to play, no ?")) {
	show("Well, too bad, you'll lose.\n\nOkay a few rules : you must reach "+
		"21 but no more, a face card (jack, queen, king) is 10, an ace is 1 or 11.")
	showButton("Yes...")
	show("That all, lets begin")
	wait(2)
}

show("We play for \$50 a hand, 2 decks, no insurance, "+
		"no split, but early surrender, no cheat.")
wait(7)

// Grab e-stim settings from Strip or Die (if set)
if(loadBoolean("stripordie.audio_estim")==null)
    save("stripordie.audio_estim",true)
if(loadString("stripordie.estim_start")==null)
    save("stripordie.estim_start","usbcontrol.exe start") // the command you use to control your device needs to be in the scripts folder
if(loadString("stripordie.estim_finish")==null)
    save("stripordie.estim_finish","usbcontrol.exe stop")
def audio_estim = loadBoolean("stripordie.audio_estim")
def estim_start = loadString("stripordie.estim_start")
def estim_finish = loadString("stripordie.estim_finish")
def estim_type = "n"

if(getBoolean("Just to make it a little more interesting, do you have a e-stim device I can control?")) {
    if (audio_estim)
	  estim_type = "a"
	else  
	  estim_type = "c"
	show("Ok, attach to your e-stim and lets get started")
	showButton("Done")
	show("try not to lose ;-)")
    if (estim_type == "c") { // Some network e-stims have a delay on first call - so best to flush at start
      useFile(estim_finish)
    }	
	wait(2)
}

// Pull the trigger
def shock = {
  if (estim_type == "a") {
    playBackgroundSound("whitequeen/estim1.wav")
  }
  if (estim_type == "c") {
    useFile(estim_start)
    wait(3)
    useFile(estim_finish)
  }
}

def money = 200
def clothes = 4
def doneCards = []
def getCard = { 
	def ok = false
	def card = null
	while(!ok) {
		card = getRandom(52)
		ok = !doneCards.contains(card)
	}
	doneCards.add(card)
	if(doneCards.size==52)
		doneCards.clear()
	return card
}
def getScore = { card -> 
	if(card<4)
		return 11
	if(card<40)
		return (int)Math.ceil((card+1)/4)
	return 10
}

def getFullScore = { cards ->
	def res = 0
	for(def c : cards)
		res += getScore(c)
	if(res>21) {
		for(def c : cards)
			if(getScore(c)==11 && res>21)
				res-=10
	}
	return (int)res
}

def getCardName = { card ->
	def values = ["ace","2","3","4","5","6","7","8","9","10","jack","queen","king"]
	def colors = ["clubs", "diamonds", "hearts", "spades"]
	return values[(int)Math.floor(card/4)]+" of "+colors[card%4]
}

def showCards= { cards -> 
	def width = 540
	def height = 500	
	def image = new java.awt.image.BufferedImage(width, height, java.awt.image.BufferedImage.TYPE_4BYTE_ABGR)
	def graphics = image.getGraphics()
	def sampleImage = java.awt.Toolkit.getDefaultToolkit().getImage(
		"images/whitequeen/0.png")
	def oneWidth = sampleImage.getWidth()
	def oneHeight = sampleImage.getHeight()
	for(def i = 0;i<cards.size;i++)
		for(def j = 0;j<cards[i].size;j++) {
			def x = j * (width - oneWidth) / (Math.max(2,cards[i].size-1))
			def delta = (i*j + i * 5 + j * 7) % 4
			def y = i * (height - oneHeight - 3) / (Math.max(1,cards.size-1)) + delta
			def thisImage = javax.imageio.ImageIO.read(new File("images/whitequeen/"+cards[i][j]+".png"))
			if(i==0) {
				graphics.rotate(Math.PI, width/2, (oneHeight + 3)/2)
			}
			graphics.drawImage(thisImage, (int)x, (int)y, null)
			if(i==0) {
				graphics.rotate(-Math.PI, width/2, (oneHeight + 3)/2)
			}
		}

	java.io.ByteArrayOutputStream baos = new java.io.ByteArrayOutputStream()
	javax.imageio.ImageIO.write(image, "jpg", baos)
	setImage(baos.toByteArray(),0)
}

def turns = 0
while(money>0 && money<400) {
	def waiting = 2 + (2 / (1+turns/4))
	def bet = 50
	money -= bet
	def cards = [[],[]]
	cards[1].add(getCard())
	showCards(cards)
	show("Your first card : "+getCardName(cards[1][0]))
	wait(waiting)
	cards[0].add(getCard())
	showCards(cards)
	show("My first card : "+getCardName(cards[0][0]))
	wait(waiting)
	cards[1].add(getCard())
	showCards(cards)
	show("Your second card : "+getCardName(cards[1][1])+", you have "+getFullScore(cards[1])+".")
	wait(waiting)
	def doubled = false
	def passed = false
	def surrendered = false
	while(getFullScore(cards[1])<21 && !passed && !doubled && !surrendered) {
		def choice = -1
		if(cards[1].size==2)
			choice = getSelectedValue("Now ?", ["Hit", "Stand", "Double", "Surrender"])
		else	
			choice = getSelectedValue("Well ?", ["Hit", "Stand"])
		passed = choice==1
		def startwords = ""
		if(choice==2) {
			doubled = true
			money -= bet
			bet *= 2
			startwords = "Ok, for \$"+bet+", "
		}
		if(choice==0 || choice==2) {
			cards[1].add(getCard())
			showCards(cards)
			show(startwords+getCardName(cards[1][cards[1].size-1])+", you have "+getFullScore(cards[1])+".")
			wait(waiting)
		}
		if(choice==3) {
			money += bet / 2
			surrendered = true
		}
	}
	if(surrendered) {
		show("Still, \$"+money+" staying for you !\n\nNext.")
	}
	else if(getFullScore(cards[1])>21) {
        shock()
		show("You lost, \$"+money+" staying for you !\n\nNext ?")
	} else {
		cards[0].add(getCard())
		showCards(cards)
		show("My second card : "+getCardName(cards[0][1])+
			", I have "+getFullScore(cards[0]))
		wait(waiting)
		while(getFullScore(cards[0])<17) {
			cards[0].add(getCard())
			showCards(cards)
			show("Then : "+getCardName(cards[0][cards[0].size-1])+
				", I have "+getFullScore(cards[0]))
			wait(waiting * 0.8)
		}
		if(getFullScore(cards[0])>21) {
			money += bet * 2
			show("Now you have \$"+money+"\n\nNext !")
		} else if(getFullScore(cards[1])==getFullScore(cards[0])) {
			if(getFullScore(cards[1])<21 || ((cards[1].size==2) == (cards[0].size==2))) {
				money += bet
				show("Push, still \$"+money+".\n\nNext hand !")
			} else if(cards[1].size==2) {				
				money += bet * 1.5
				show("Blackjack versus point, good, now \$"+money+".\n\nNext !")				
			} else if(cards[1].size==2) {
                shock()
				show("Point but blackjack for me, now at \$"+money+".\n\nNext !")				
			} 
		} else if(getFullScore(cards[1])>getFullScore(cards[0])) {
			money += bet * 2
			show("You win, \$"+money+" now.\n\nLet's play again !")						
		} else {
            shock()
			show("You lost, you've got \$"+money+" now.\n\nNext hand !")
		}
	}
	
	if(money<=200 && getRandom(2)==0)
		setImage(imPrefix+"1.jpg")
	else if(money<=200)
		setImage(imPrefix+"2.jpg")
	else if(money<=250 && getRandom(2)==0)
		setImage(imPrefix+"3.jpg")
	else if(money<=250)
		setImage(imPrefix+"4.jpg")
	else if(money<=300 && getRandom(2)==0)
		setImage(imPrefix+"5.jpg")
	else if(money<=300)
		setImage(imPrefix+"6.jpg")
	else if(money<=325)
		setImage(imPrefix+"7.jpg")
	else if(money<=350 && getRandom(2)==0)
		setImage(imPrefix+"8.jpg")
	else if(money<=350)
		setImage(imPrefix+"9.jpg")
	else
		setImage(imPrefix+"10.jpg")
	wait(waiting)
	
	// Strip players clothes (once removed don't get back)
	if(money<=150 && clothes > 3) {
	  show("Remove an item of clothing (3 left)")
	  showButton("Done")
      clothes = 3
	}
	if(money<=100 && clothes > 2) {
	  show("Remove an item of clothing (2 left)")
	  showButton("Done")
      clothes = 2
	}
	if(money<=50 && clothes > 1) {
	  show("Remove an item of clothing (1 left)")
	  showButton("Done")
      clothes = 1
	}
	if(money<=10 && clothes > 0) {
	  show("Remove an item of clothing (Naked)")
	  showButton("Done")
      clothes = 0
	}

	turns++
}
	
if(money<=0) {
	show("That's it, you lost.")
	wait(5)
    shock()
	setImage(imPrefix+"1.jpg")
	show("Too bad for you, thank your friends for me.")
} else {
	show("Well, it looks like you are lucky tonight.")
	wait(5)
    if (estim_type != "n") {
	  show("Good for you, why don't you remove that estim and those clothes for me ?")
    } else {
	  show("Good for you, why don't you remove those clothes for me ?")
	}  
	wait(10)
	setImage(imPrefix+"10.jpg")
	if(loadBoolean("intro.female"))
		show("Well, lets start with a few moves that you like and with ".
			"the good pressure, have this ready.")
	else
		show("Well, lets start with a few strokes.")
	wait(5)
	for(def i = 0;i<150+getRandom(50);i++) {
		playBackgroundSound("tom.wav")
		if(i==40)
			setImage(imPrefix+"11.jpg")
		if(i==80)
			setImage(imPrefix+"12.jpg")
		if(i==100)
			show("Oh, it looks I'm late for my next customer.")
		if(i==140)
			show("Be quick now, I'm leaving in a minute, no time for more.")
		wait(0.6-i/500.0)
	}
	setImage(imPrefix+"13.jpg")
	show("Thank your friends for me.")	
}
wait(5)
setImage(null)
show("")

/* 
 * Resources
 * scripts/whitequeen.groovy
 * images/whitequeen/*
 * sounds/whitequeen/estim1.wav 
 */
// This script, from http://ss.deviatenow.com, is protected by this licence : 
// CC by-NC, see http://creativecommons.org/licenses/by-nc/3.0/
